function [ Costx, Snext ] = NEXT( S3, x3, t3 )

%Calculate the capacity of next state under action x



%   Snext: Next states at time t+1

%   Costx: Cost of taking action x at time t



global PP  E_CONC n EM CST Cost S D F

global CCR ER aCC aE b CCCOAL ECOAL CapFac prd ndbl nd ER0 CCR0



Snext = zeros(5 * n + 1, 1);

NOC = zeros(n, 1);

OOC = zeros(n, 1);

GOC = zeros(n, 1);

NCC = zeros(n, 1);

OCC = zeros(n, 1);





%   Operating Capacity MW

    % New Net Operating Capacity at time (NOC) without x3

    % OLd Net Operating Capacity at time (OOC)

    % Gross Net Operating Capacity at (GOC)

    % Electricity Deficit (EDEF)

    % Electricity Required at time t (EREQ)

    xdate = max(0, t3 + 1 - PP(:, 4));

    odate = max(0, t3 + 1 - PP(:, 5));

    for i=1:1:n

        for j=t3-1:-1:max(xdate(i), 1)

            NOC(i) = NOC(i) + S(i, j) / PP(i, 4);

        end

        for j=t3:-1:odate(i)+ 1

            jj = t3 + 1 - j;

            OOC(i) = OOC(i) + ((S(2 * n + i, j)) * (1 - jj / PP(i, 5)));

        end

        % OLd Net Operating Capacity at time t+1

        Snext(3 * n + 1:4 * n) = OOC;

        % Gross Net Operating Capacity at time t+1 

        GOC(i) = NOC(i) + OOC(i);

    end



    % Electricity Deficit at time t+1

    EDEF = sum(D(:, t3 + 1)) - sum(GOC);

    SPPx = sum (x3./(PP(:, 4)));

    % Electricity Required at time t

    EREQ = EDEF / SPPx;      

 

%   Construction Capacity MW

    % New Construction Capacity(NCC)

    % OLd Construction Capacity(OCC)

    NCC = x3 * EREQ;

    

    % New Net Construction Capacity at time t

    S(1:n, t3) = NCC;

    

    for i=1:1:n

        for j=t3:-1:xdate(i)+1

            jj = t3 + 1 - j;

            OCC(i) = OCC(i) + (((PP(i, 4) - jj) / PP(i, 4)) * S(i, j));

        end

        % Old Net Construction Capacity at time t+1

        Snext(n + i) = OCC(i);

    end

   

% New Net Operating Capacity at time t+1

Snext(2 * n + 1:3 * n) = NOC + (NCC./(PP(:, 4)));



%   TOTAL CAPACITY

    % Total Net Construction Capacity at time t

    CONCAP = S(1:n, t3) + S(n + 1:2 * n, t3);

    % Total Net Operating Capacity at time t

    OPCAP = S(2 * n + 1:3 * n, t3) + S(3 * n + 1:4 * n, t3);

    % Total Net Operating Capacity at time t + 1

    OPCAP2 = Snext(2 * n + 1:3 * n) + Snext(3 * n + 1:4 * n);

    % Total built Capacity at time t + 1

    Snext(4 * n + 1:5 * n) = S(4 * n + 1:5 * n, t3) + Snext(2 * n + 1:3 * n)./CapFac(:, t3 + 1);

    if t3==1

        S(4 * n + 1:5 * n, 2) = Snext(4 * n + 1:5 * n);

    end

% LEARNING

    for i = 1:1:n

        capdbl = Snext(4 * n + i);

        if (Snext(4 * n + i) >= 2 * S(4 * n + i, t3))

            capdbl = 2 * S(4 * n + i, t3);

            ndbl(prd(i), i) = ndbl(prd(i), i) + 1;

            if prd(i) < 3

                if (ndbl(prd(i), i) == nd(prd(i), i))

                    prd(i) = prd(i) + 1;

                end

            end

        end

        aCC(i, t3) = CCR(i, t3)*(exp(b(prd(i), i)*log(S(4 * n + i, t3))));

        aE(i, t3) = ER(i, t3)*(exp(b(prd(i), i)*log(S(4 * n + i, t3))));

    

        % Cost ratio update

        CCR(i, t3 + 1) = min (CCR(i, t3), aCC(i, t3)*exp(-b(prd(i), i)*log(capdbl)));

            % CCS Cost is constrained above the Coal cost

            CCR(7, t3 + 1) = max (CCR(1, t3 + 1), CCR(7, t3 + 1));        

        

        % Emission ratio update

        ER(i, t3 + 1) = min (ER(i, t3), aE(i, t3)*exp(-b(prd(i), i)*log(capdbl))); 

    end



%	Emissions (Million tons)

    for i = 1:1:3

        CEM = CONCAP.*(PP(:, 5 + i)./PP(:, 4));

        OEM = OPCAP.*PP(:, 8 + i);

        EM(i, t3)  = (sum(CEM + OEM))/ 1e6;

    end



    % Emission Concentraition at time t (Mt)

    E_CONC(:, t3) = CONC(t3);



    % Radiative Forcing at time t (W/m2)

    deltaF = FORCE(E_CONC(:, t3));



    % Atmospheric Temperature

    Snext(5 * n + 1) = TEMP(S3(5 * n + 1), deltaF);



% Cost (Billion$)



    % Electricity Cost  (Billion$)

        % Construction Cost

        CST(:, 1, t3) = (CONCAP.*(PP(:, 1)./CapFac(:, t3))) / 1e6;

        % Fixed O&M Cost

        CST(:, 2, t3) = (OPCAP.*(PP(:, 2)./CapFac(:, t3))) / 1e6;

        % Variable O&M Cost

        CST(:, 3, t3) = (OPCAP.*PP(:, 3))* 365 * 24 / 1e9;

        % Fuel Cost

        CST(:, 4, t3) = (OPCAP.*PP(:, 12).*F(:, t3))* 365 * 24 / 1e12;

        % Total Electricity Generation Cost

        Cost(1, t3) = sum(CST(:, 1, t3)) + sum(CST(:, 2, t3)) + sum(CST(:, 3, t3)) + sum(CST(:, 4, t3));

        

    % Damage Cost  (Billion$)

        Cost(2, t3) = exp(10*Snext(5 * n + 1));

        

    % Total Cost  (Billion$)

        Costx = (1 * Cost(1, t3)) + (0 * Cost(2, t3));

        

    % Power Plant update

        PP(:, 1) = CCR(:, t3 + 1).*CCCOAL;

        PP(:, 6) = ER(:, t3 + 1).*ECOAL;        



end



